// Image.hh for fbdesk
// Copyright (c) 2002 Henrik Kinnunen (fluxgen at users.sourceforge.net)
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

// $Id$


#ifndef FBTK_IMAGE_HH
#define FBTK_IMAGE_HH

#include "NotCopyable.hh"
#include <map>
#include <string>

namespace FbTk  {

class Surface;

class ImageBase;

class Image:public NotCopyable
{
public:
    static Image &instance();
    void add(ImageBase &img, const std::string &tag);
    void remove(ImageBase &img);
    static Surface *load(const char *filename);
    static bool save(const char *filename, const Surface &img);

private:
    Image();
    ~Image();
    static std::string findExtension(const char *filename);
    static ImageBase *findImageBase(const std::string& ext);	
    typedef std::map<std::string, ImageBase *> ImageList;
    ImageList m_imagelist;
};

}; //end namespace FbTk
#endif // FbTk_IMAGE_HH
